"use strict";
/* c8 ignore start */
Object.defineProperty(exports, "__esModule", { value: true });
exports.findPID = exports.killPID = void 0;
const node_child_process_1 = require("child_process");
const node_os_1 = require("os");
exports.killPID = {
    unix: (PID) => new Promise((resolve) => {
        try {
            const service = (0, node_child_process_1.spawn)('kill', ['-9', String(PID)]);
            service.on('close', () => {
                resolve(undefined);
            });
        }
        catch (_a) {
            resolve(undefined);
        }
    }),
    windows: (PID) => new Promise((resolve) => {
        try {
            const service = (0, node_child_process_1.spawn)('taskkill', ['/F', '/T', '/PID', String(PID)]);
            service.on('close', () => {
                resolve(undefined);
            });
        }
        catch (_a) {
            resolve(undefined);
        }
    }),
};
exports.findPID = {
    unix: (port) => new Promise((resolve) => {
        try {
            const PIDs = new Set();
            const service = (0, node_child_process_1.spawn)('lsof', ['-t', '-i', `:${Number(port)}`]);
            service.stdout.on('data', (data) => {
                const output = data.toString().trim().split(node_os_1.EOL);
                output.forEach((pid) => {
                    if (pid)
                        PIDs.add(Number(pid));
                });
                service.on('close', () => {
                    resolve(Array.from(PIDs));
                });
            });
        }
        catch (_a) { }
    }),
    windows: (port) => new Promise((resolve) => {
        try {
            const PIDs = new Set();
            const service = (0, node_child_process_1.spawn)('cmd.exe', [
                '/c',
                `netstat -aon | findstr :${Number(port)}`,
            ]);
            service.stdout.on('data', (data) => {
                const output = data.toString().trim();
                const lines = output.trim().split(node_os_1.EOL);
                lines.map((line) => {
                    const tokens = line.trim().split(/\s+/);
                    PIDs.add(Number(tokens[4]));
                });
            });
            service.on('close', () => {
                resolve(Array.from(PIDs));
            });
            service.stderr.on('data', (data) => {
                console.error(`Erro: ${data}`);
            });
        }
        catch (_a) { }
    }),
};
/* c8 ignore stop */
